package com.syc.slm.slmbi.controller;

import com.google.common.collect.Maps;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.common.core.util.NetResponseUtils;
import com.syc.slm.common.core.util.R;
import com.syc.slm.slmbi.function.Action0;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.ModelAttribute;

import javax.servlet.http.HttpServletRequest;
import java.util.Enumeration;
import java.util.Map;
import java.util.function.Supplier;

/**
 * slm-bi
 * 抽取公用得controller父类
 *
 * @author : lin
 * @date : 2021-04-06 09:09
 **/
@Slf4j

public class BaseRestController {
    protected String token;
    protected String uid;
    protected String platformId;
    @Value("${dc_client.host}")
    protected String dcClientHost;
    @Value("${dc_client.interfaces.positionListUrl}")
    protected String positionListUrl;
    @Value("${dc_client.interfaces.deptListUrl}")
    protected String deptListUrl;
    @Value("${dc_client.interfaces.getOfficeIds}")
    protected String getOfficeIds;
    @Value("${dc_client.interfaces.userTree}")
    protected String userTree;
    @ModelAttribute
    public void onInit(HttpServletRequest request) {
        String uri = request.getRequestURI();
        log.info("请求url--->>>>" + uri);
        Map<String, String[]> parameterMap = request.getParameterMap();
        log.info("请求参数--->>>>"+SlmConstants.gson.toJson(parameterMap));
        Enumeration<String> headerNames = request.getHeaderNames();
        Map<String,String> headers = Maps.newHashMap();
        while (headerNames.hasMoreElements()){
            String headerName = headerNames.nextElement();
            Enumeration<String> headerValues = request.getHeaders(headerName);
            while(headerValues.hasMoreElements()){
                headers.put(headerName, headerValues.nextElement());
            }

        }
        token=request.getHeader("token");
        log.info("请求头参数--->>>>"+SlmConstants.gson.toJson(headers));
    }
    R<Object> call(Action0 action) {
        return NetResponseUtils.call(action);
    }

    <T> R<T> call(Supplier<T> supplier) {
        return NetResponseUtils.call(supplier);
    }
}
