package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.google.common.collect.Maps;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.vo.DeptVo;
import com.syc.slm.slmbi.service.DeptService;
import com.syc.slm.slmbi.vo.PositionVo;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 部门信息
 *
 * @author : lin
 * @date : 2021-03-25 18:41
 **/
@Service
public class DeptServiceImpl implements DeptService {


    @Override
    public List<DeptVo> selectPositionList(String uri, String token, String appId, String deptName) {
        Map<String,String> heads = Maps.newHashMap();
        heads.put("token",token);
        Map<String,String> uriVariables =Maps.newHashMap();
        uriVariables.put("deptName",deptName);
        uriVariables.put("appId",appId);

        R<List<DeptVo>> r = new R<>();
        ResponseEntity<String> responseEntity = RestTemplateUtils.get(uri, heads, String.class, uriVariables);
        if(ObjectUtils.isNotEmpty(responseEntity)){
            String body = responseEntity.getBody();
            r= SlmConstants.gson.fromJson(body, new TypeToken<R<List<DeptVo>>>(){}.getType());
        }
        return r.detach();
    }
}
