package com.syc.slm.slmbi.service.impl;

import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.google.common.collect.Maps;
import com.google.gson.reflect.TypeToken;
import com.syc.slm.common.core.constant.SlmConstants;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.service.UserService;
import com.syc.slm.slmbi.vo.DeptVo;
import com.syc.slm.slmbi.vo.UserTreeVo;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 用户信息
 *
 * @author : lin
 * @date : 2021-03-25 18:46
 **/
@Service
public class UserServiceImpl implements UserService {
    @Override
    public List<UserTreeVo> selectUserList(String appId,String uri,String token,String userName) {
        Map<String,String> heads = Maps.newHashMap();
        heads.put("token",token);
        Map<String,String> uriVariables =Maps.newHashMap();
        uriVariables.put("userName",userName);
        uriVariables.put("appId",appId);

        R<List<UserTreeVo>> r = new R<>();
        ResponseEntity<String> responseEntity = RestTemplateUtils.get(uri, heads, String.class, uriVariables);
        if(ObjectUtils.isNotEmpty(responseEntity)){
            String body = responseEntity.getBody();
            r= SlmConstants.gson.fromJson(body, new TypeToken<R<List<UserTreeVo>>>(){}.getType());
        }
        return r.detach();
    }
}
